SPOJ-9652 Robots on a grid 解题报告

Description

You have recently made a grid traversing robot that can finnd its way from the top left corner of a grid to the bottom right corner. However, you had forgotten all your AI programming skills, so you only programmed your robot to go rightwards and downwards (that's after all where the goal is). You have placed your robot on a grid with some obstacles, and you sit and observe. However, after a while you get tired of observing it getting stuck, and ask yourself How many paths are there from the start position to the goal position?", and \If there are none, could the robot have made it to the goal if it could walk upwards and leftwards?" So you decide to write a program that, given a grid of size n x n with some obstacles marked on it where the robot cannot walk, counts the di erent ways the robot could go from the top left corner s to the bottom right t, and if none, tests if it were possible if it could walk up and left as well. However, your program does not handle very large numbers, so the answer should be given modulo 2^31 - 1.

Input

On the fi rst line is one integer, 1 < n <= 1000. Then follows n lines, each with n characters, where each character is one of '.' and '#', where '.' is to be interpreted as a walkable tile and '#' as a non-walkable tile. There will never be a wall at s, and there will never be a wall at t.

Output

Output one line with the number of di erent paths starting in s and ending in t (modulo 2^31 - 1) or THE GAME IS A LIE if you cannot go from s to t going only rightwards and  downwards but you can if you are allowed to go left and up as well, or INCONCEIVABLE if  there simply is no path from s to t.

Sample Input

5
.....
#..#.
#..#.
...#.
.....

Sample Output

6

       题目链接:http://www.spoj.pl/problems/ROBOTGRI/
       解法类型:DP+BFS ||其它
       解题思路:这是今天师大比赛的一个题目,我一开始想到是用DP做的。题目要求在向右和向下走的可行路径数,想到用从起始点s开始,分别记录可行路径数,即动态规划,然后进行状态转移,记录下一个。
以Sample Input 为例:分别的状态数为11111
                                                                01201
                                                                01301
                  01401
                  01556
很容易得出状态转移方程:d[i][j]=d[i-1][j]>?=0+d[i][j-1]>?=0;
最后就是“THE GAME IS A LIE”和“INCONCEIVABLE”情况的处理了,直接用BFS从目标点d开始扩展即可,知道遇到了状态数大于0的就找到是THE GAME IS A LIE”的情况。否则INCONCEIVABLE”
注意“so the answer should be given modulo 2^31 - 1.”!我因为没有注意到要取模,WA到痛不欲生。(@﹏@)~ 
       算法实现:
//STATUS:C++_AC_513MS_17344KB
#include
#include
const int MAXN=1010,mod=0x7fffffff;
void BFS(int x,int y);
char map[MAXN][MAXN];
__int64 d[MAXN][MAXN];
int q[MAXN*MAXN],n,dx[4]={-1,0,1,0},
dy[4]={0,-1,0,1},ans,vis[MAXN][MAXN];
int main()
{
//	freopen("in.txt","r",stdin);
	int i,j,ok;
	while(~scanf("%d",&n))
	{
		ans=0;
		memset(d,0,sizeof(d));
		for(i=0;i0 && d[i][j-1]!=0 && map[i][j]=='.')d[i][j]=(d[i][j]+d[i][j-1])%mod,ok=1;   //righwards
			}
			if(!ok){break;}   //无法达到要求,第一种情况排除
		}
		if(!d[n-1][n-1]){  //判断第二或第三种情况
			memset(vis,0,sizeof(vis));
			BFS(n-1,n-1);
		}
		if(d[n-1][n-1])printf("%I64d\n",d[n-1][n-1]);
		else printf("%s\n",ans==1?"THE GAME IS A LIE":"INCONCEIVABLE");
	}
	return 0;
}	

void BFS(int x,int y)    //搜索目标状态
{
	int front=0,rear=0,i,nx,ny,u;
	u=x*n+y;
	q[rear++]=u;
	vis[x][y]=1;
	while(front=0&&nx=0&&ny

你可能感兴趣的:(ACM_DP,ACM_BFS)